// 
// bbs.chx

#include "stdafx.h"
#include "..\common\WebUtil.h"
#include "db.h"

#define SCRIPT_NAME	"$script_name&"

CRITICAL_SECTION cs;

inline char AtoH( char c );
BOOL	MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen);
BOOL	MakeItem( MyVarMem* pBody, MyVarMem* pRes, MyVarMem* pDst);
void	GetQueryStringValue( const char* pszQS, const char* pszKey, char* pszValue, int nValueLen );
BOOL	GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen);
HANDLE	CreateFileMBCS(LPCSTR lpFileName, DWORD dwDesiredAccess, 
			DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, 
			DWORD dwCreationDispostion , DWORD dwFlagsAndAttributes, HANDLE hTemplateFile );

// ----------------------------------------------------------------------------
// CreateFileMBCS
// ----------------------------------------------------------------------------
HANDLE CreateFileMBCS(LPCSTR lpFileName, DWORD dwDesiredAccess, 
		DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, 
		DWORD dwCreationDispostion , DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
	TCHAR* pT;
	int nTlen;
	HANDLE hRet;
	nTlen = MultiByteToWideChar(CP_ACP, 0, lpFileName, -1, NULL, 0);

	pT = new TCHAR[nTlen];
	if( pT == NULL )
	{
		return INVALID_HANDLE_VALUE;
	}

	nTlen = MultiByteToWideChar(CP_ACP, 0, lpFileName, -1, pT, nTlen);

	hRet =  CreateFile(
		pT, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDispostion ,dwFlagsAndAttributes, hTemplateFile );

	delete[] pT;
	
	return hRet;

}

// ----------------------------------------------------------------------------
// FileMyVarMem֗
// ----------------------------------------------------------------------------
BOOL FileToMyVarMem(char* pszFileName, MyVarMem* pVM)
{
	DWORD dwReadBytes;
	HANDLE hFile;

	char	szBuf[256];

	hFile = CreateFileMBCS(pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	
	if( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	do
	{
		BOOL bResult;
		bResult = ReadFile( hFile, szBuf, 256, &dwReadBytes, NULL );
		if (bResult == 0 || dwReadBytes == 0)
			break;

		pVM->Add(szBuf, dwReadBytes);

	}while(1);

	CloseHandle( hFile );
	return TRUE;
}

// ----------------------------------------------------------------------------
// HTML wb_[o
// ----------------------------------------------------------------------------
void HTML_HEADER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add( 
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n"
		"<HTML><HEAD>\n"
		"<TITLE>CEHTTP BBS</TITLE>\n"
		"</HEAD>\n"
		"<BODY BGCOLOR=#FFFFFF>\n");
	return;
}

// ----------------------------------------------------------------------------
// FORM ̏
// name		: O
// email	: [AhX
// subject	: 薼
// body		; e
// ----------------------------------------------------------------------------
void HTML_FORM( MyHash* pEnv, MyVarMem* pRes )
{
	char* pszScriptName = pEnv->GetValueI("SCRIPT_NAME");

	pRes->Add("<form method=POST action=\"");
	pRes->Add(pszScriptName);
	pRes->Add("\"><TT>");

	pRes->Add(
		"e <input type=text name=\"name\" size=20 value=\"\" maxlength=24><br>"
		"[ <input type=text name=\"email\" size=30 value=\"\"><br>"
		"@ <input type=text name=\"subject\" size=30><br>"
		"@e <br></TT>"
		"<textarea name=\"body\" rows=5 cols=80></textarea>"
		"<input type=submit value=\"     e     \"><input type=reset value=\"\">"
		"</form>"
		);
}

// ----------------------------------------------------------------------------
// HTML tb^[o
// ----------------------------------------------------------------------------
void HTML_FOOTER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add(
		"<P><A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">CEHTTP BBS by IshiSoft</A>"
		"</BODY></HTML>\n");
}

// ----------------------------------------------------------------------------
// JgfBNg擾
// ----------------------------------------------------------------------------
BOOL GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen)
{
	//SCRIPT_NAME=/scripts/sample.chx
	//DOCUMENT_ROOT=\wwwroot

	char* pszDocmentRoot = pEnv->GetValue("DOCUMENT_ROOT");
	char* pszScriptName = pEnv->GetValue("SCRIPT_NAME");

	if( !pszDocmentRoot || !pszScriptName )
		return FALSE;

	int nDocmentRoot = strlen(pszDocmentRoot);
	int nScriptName = strlen(pszScriptName);

	if( nDocmentRoot + nScriptName >= nDstNameLen )
		return FALSE;
	
	strcpy(pszDstName, pEnv->GetValue("DOCUMENT_ROOT"));
	strcat(pszDstName, pEnv->GetValue("SCRIPT_NAME"));

	char* p = pszDstName;

	do{
		if( *p == '/' )
			*p = '\\';
	}while( *p++ != '\0' );

	p--;

	while( *p != '\\' )
	{
		if( p == pszDstName ) break;

		*p-- = '\0';
	};

	return TRUE;
}


// ----------------------------------------------------------------------------
// t@C؂o(Prefix)
// ----------------------------------------------------------------------------
BOOL MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen)
{
	int ii = 0;

	if( pszSrcFilePath == NULL )
		return FALSE;

	// "c:\xxxx\xxxx\xxxx.abc"
	char* p = pszSrcFilePath + 1;

	// pŌ܂Ői߂
	while( *p != '\"' && *p != '\0' )
		p++;

	//*p = '\0';
	p--;

	while( *p != '\\' && *p != '\0' && *p != '\"' && *p != '/' )
		p--;

	p++;

	strcpy( pszDstFileName, "CEHTTP_" );
	nFileNameLen -= 7;
	pszDstFileName += 7;

	while( *p != '\"' && *p != '\0' && ii++ < nFileNameLen )
		*pszDstFileName++ = *p++;

	*pszDstFileName = '\0';

	return TRUE;
}

// ----------------------------------------------------------------------------
// t@C؂o(prefixȂ)
// ----------------------------------------------------------------------------
BOOL GetScriptName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen)
{
	int ii = 0;

	if( pszSrcFilePath == NULL )
		return FALSE;

	// "c:\xxxx\xxxx\xxxx.abc"
	char* p = pszSrcFilePath + 1;

	// pŌ܂Ői߂
	while( *p != '\0' )
		p++;

	//*p = '\0';
	p--;

	while( *p != '\\' && *p != '\0' && *p != '/' )
		p--;

	p++;

	while( *p != '.' && *p != '\0' && ii++ < nFileNameLen )
		*pszDstFileName++ = *p++;

	*pszDstFileName = '\0';

	return TRUE;
}

// ----------------------------------------------------------------------------
// QUERY_STRING lǂݏo
// keyɂ "xxxx=" Ƃ=܂Ŋ܂߂邱
// ----------------------------------------------------------------------------
void GetQueryStringValue( const char* pszQS, const char* pszKey, char* pszValue, int nValueLen )
{
	memset( pszValue, 0, nValueLen );
	if( pszQS == NULL )
		return;

	char* p = strstr( pszQS, pszKey );
	if( p == NULL )
		return;

	while( (*p != '=') && (*p != '\0') ) *p++;

	if( *p == '\0' )
		return;

	p++;

	for( ;(*p != '&') && (*p != '\0') && (nValueLen); p++, pszValue++, nValueLen-- )
	{
		*pszValue = *p;
	}

	UnEscape( pszValue );
}

//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	char	pszScriptName[256] = {0};
	TCHAR	ptszScriptName[256] = {0};
	char	pszErrBadScriptName[] = "Bad script name";
	char	pszKey[] = "SCRIPT_NAME";

	WebUtil wu( pEnv, pBody, pRes );

	// --------------------------------------------------------------
	// db̍쐬
	// --------------------------------------------------------------
	if( MyGetFileName( pEnv->GetValueI("SCRIPT_NAME"), pszScriptName, 256 ) == FALSE )
	{
		Error( pRes, pszErrBadScriptName );
		return pRes->GetLength();
	}

	if( 0 == MultiByteToWideChar(CP_ACP, 0, pszScriptName, -1, ptszScriptName, 256) )
	{
		Error( pRes, pszErrBadScriptName );
		return pRes->GetLength();
	}

	// --------------------------------------------------------------
	// POST̏
	// --------------------------------------------------------------
	if( 0 == strcmp( pEnv->GetValue("REQUEST_METHOD"), "POST" ) )
	{
		char szSubmitName[32] = {0};

		// --------------------------------------------------------------
		// e
		// --------------------------------------------------------------
		wu.GetItem( "postitem", szSubmitName, 31 );

		if( 0 != strlen(szSubmitName) )
		{
			if( !ItemAdd( ptszScriptName, pBody, pRes ) )
			{
				return pRes->GetLength();
			}
		}
		
		// --------------------------------------------------------------
		// 폜
		// --------------------------------------------------------------
		wu.GetItem( "deleteitem", szSubmitName, 31 );
		
		if( 0 != strlen(szSubmitName) )
		{
			DWORD dwDeleteId = 0;
			char szDeleteId[12] = {0};

			dwDeleteId = wu.GetItemInt( "deleteitemid" );

			if( 0 != dwDeleteId )
			{
				if( !ItemDelete(ptszScriptName, dwDeleteId, pRes ) )
				{
					sprintf(szDeleteId,"%X", dwDeleteId);
					Error(pRes, szDeleteId);
					return pRes->GetLength();
				}
			}
		}

		pRes->Clear();
		pRes->Add("Location: ");
		pRes->Add(pEnv->GetValue("SCRIPT_NAME"));
		pRes->Add("\r\n\r\n");
		return pRes->GetLength();
	}


	// --------------------------------------------------------------
	char szStartRow[12] = {0};
	DWORD nStartRow = 0;
	GetQueryStringValue( pEnv->GetValueI("QUERY_STRING"), "row", szStartRow, 12 );
	nStartRow = (unsigned long)atol( szStartRow );
	// nStartRow = HtoDWORD( szStartRow );


	pRes->Clear();
	pRes->Add( "Content-Type: text/html; Charset=Shift_JIS\r\n\r\n" );

	// --------------------------------------------------------------
	// HTML ̍쐬
	// --------------------------------------------------------------
	char	szBuf[MAX_PATH];
	char	szScriptName[64];
	GetScriptName( pEnv->GetValueI( "SCRIPT_NAME" ), szScriptName, 64 );

	GetScriptCurrentDir(pEnv, szBuf, MAX_PATH - 40);
	strcat(szBuf, szScriptName);
	strcat(szBuf, HTMLHEADFILE);

	if( FileToMyVarMem( szBuf, pRes ) == FALSE )
	{
		HTML_HEADER(pEnv, pRes);
		pRes->Add("\n<!-- ERROR READ FILE ");
		pRes->Add(szBuf);
		pRes->Add(" -->\n");
		HTML_FORM(pEnv, pRes);
	}

	BOOL bHideDeleteID;

	if( strstr( (const char*)pRes, "$HIDE_DELETE_FLAG$" ) == NULL )
		bHideDeleteID = TRUE;
	else
		bHideDeleteID = FALSE;

	ItemRead( ptszScriptName, pEnv, pBody, pRes, nStartRow, bHideDeleteID );

	GetScriptCurrentDir(pEnv, szBuf, MAX_PATH - 40);
	strcat(szBuf, szScriptName);
	strcat(szBuf, HTMLFOOTFILE);

	if( FileToMyVarMem( szBuf, pRes ) == FALSE )
	{
		HTML_FOOTER(pEnv, pRes);
	}
	return pRes->GetLength();

}


//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch( ul_reason_for_call )
	{
	case DLL_PROCESS_ATTACH:
		{
//			InitializeCriticalSection(&cs);
			break;
		}
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		{
//			DeleteCriticalSection( &cs );
			break;
		}
    }

    return TRUE;
}

